package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class CwGlDetailExample {
    /**
     * cw_gl_detail
     */
    protected String orderByClause;

    /**
     * cw_gl_detail
     */
    protected boolean distinct;

    /**
     * cw_gl_detail
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public CwGlDetailExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * @mbg.generated 2019-10-14
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * cw_gl_detail 2019-10-14
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andPkDetailIsNull() {
            addCriterion("PK_DETAIL is null");
            return (Criteria) this;
        }

        public Criteria andPkDetailIsNotNull() {
            addCriterion("PK_DETAIL is not null");
            return (Criteria) this;
        }

        public Criteria andPkDetailEqualTo(String value) {
            addCriterion("PK_DETAIL =", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailNotEqualTo(String value) {
            addCriterion("PK_DETAIL <>", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailGreaterThan(String value) {
            addCriterion("PK_DETAIL >", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailGreaterThanOrEqualTo(String value) {
            addCriterion("PK_DETAIL >=", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailLessThan(String value) {
            addCriterion("PK_DETAIL <", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailLessThanOrEqualTo(String value) {
            addCriterion("PK_DETAIL <=", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailLike(String value) {
            addCriterion("PK_DETAIL like", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailNotLike(String value) {
            addCriterion("PK_DETAIL not like", value, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailIn(List<String> values) {
            addCriterion("PK_DETAIL in", values, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailNotIn(List<String> values) {
            addCriterion("PK_DETAIL not in", values, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailBetween(String value1, String value2) {
            addCriterion("PK_DETAIL between", value1, value2, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkDetailNotBetween(String value1, String value2) {
            addCriterion("PK_DETAIL not between", value1, value2, "pkDetail");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIsNull() {
            addCriterion("PK_GLORGBOOK is null");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIsNotNull() {
            addCriterion("PK_GLORGBOOK is not null");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookEqualTo(String value) {
            addCriterion("PK_GLORGBOOK =", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotEqualTo(String value) {
            addCriterion("PK_GLORGBOOK <>", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookGreaterThan(String value) {
            addCriterion("PK_GLORGBOOK >", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookGreaterThanOrEqualTo(String value) {
            addCriterion("PK_GLORGBOOK >=", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLessThan(String value) {
            addCriterion("PK_GLORGBOOK <", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLessThanOrEqualTo(String value) {
            addCriterion("PK_GLORGBOOK <=", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLike(String value) {
            addCriterion("PK_GLORGBOOK like", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotLike(String value) {
            addCriterion("PK_GLORGBOOK not like", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIn(List<String> values) {
            addCriterion("PK_GLORGBOOK in", values, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotIn(List<String> values) {
            addCriterion("PK_GLORGBOOK not in", values, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookBetween(String value1, String value2) {
            addCriterion("PK_GLORGBOOK between", value1, value2, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotBetween(String value1, String value2) {
            addCriterion("PK_GLORGBOOK not between", value1, value2, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIsNull() {
            addCriterion("PK_VOUCHER is null");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIsNotNull() {
            addCriterion("PK_VOUCHER is not null");
            return (Criteria) this;
        }

        public Criteria andPkVoucherEqualTo(String value) {
            addCriterion("PK_VOUCHER =", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotEqualTo(String value) {
            addCriterion("PK_VOUCHER <>", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherGreaterThan(String value) {
            addCriterion("PK_VOUCHER >", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHER >=", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLessThan(String value) {
            addCriterion("PK_VOUCHER <", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHER <=", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLike(String value) {
            addCriterion("PK_VOUCHER like", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotLike(String value) {
            addCriterion("PK_VOUCHER not like", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIn(List<String> values) {
            addCriterion("PK_VOUCHER in", values, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotIn(List<String> values) {
            addCriterion("PK_VOUCHER not in", values, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherBetween(String value1, String value2) {
            addCriterion("PK_VOUCHER between", value1, value2, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHER not between", value1, value2, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPreparedateIsNull() {
            addCriterion("PREPAREDATE is null");
            return (Criteria) this;
        }

        public Criteria andPreparedateIsNotNull() {
            addCriterion("PREPAREDATE is not null");
            return (Criteria) this;
        }

        public Criteria andPreparedateEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE =", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE <>", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateGreaterThan(Date value) {
            addCriterionForJDBCDate("PREPAREDATE >", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE >=", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLessThan(Date value) {
            addCriterionForJDBCDate("PREPAREDATE <", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("PREPAREDATE <=", value, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateIn(List<Date> values) {
            addCriterionForJDBCDate("PREPAREDATE in", values, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotIn(List<Date> values) {
            addCriterionForJDBCDate("PREPAREDATE not in", values, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("PREPAREDATE between", value1, value2, "preparedate");
            return (Criteria) this;
        }

        public Criteria andPreparedateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("PREPAREDATE not between", value1, value2, "preparedate");
            return (Criteria) this;
        }

        public Criteria andDetailindexIsNull() {
            addCriterion("DETAILINDEX is null");
            return (Criteria) this;
        }

        public Criteria andDetailindexIsNotNull() {
            addCriterion("DETAILINDEX is not null");
            return (Criteria) this;
        }

        public Criteria andDetailindexEqualTo(String value) {
            addCriterion("DETAILINDEX =", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexNotEqualTo(String value) {
            addCriterion("DETAILINDEX <>", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexGreaterThan(String value) {
            addCriterion("DETAILINDEX >", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexGreaterThanOrEqualTo(String value) {
            addCriterion("DETAILINDEX >=", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexLessThan(String value) {
            addCriterion("DETAILINDEX <", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexLessThanOrEqualTo(String value) {
            addCriterion("DETAILINDEX <=", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexLike(String value) {
            addCriterion("DETAILINDEX like", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexNotLike(String value) {
            addCriterion("DETAILINDEX not like", value, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexIn(List<String> values) {
            addCriterion("DETAILINDEX in", values, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexNotIn(List<String> values) {
            addCriterion("DETAILINDEX not in", values, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexBetween(String value1, String value2) {
            addCriterion("DETAILINDEX between", value1, value2, "detailindex");
            return (Criteria) this;
        }

        public Criteria andDetailindexNotBetween(String value1, String value2) {
            addCriterion("DETAILINDEX not between", value1, value2, "detailindex");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNull() {
            addCriterion("ABSTRACTS is null");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNotNull() {
            addCriterion("ABSTRACTS is not null");
            return (Criteria) this;
        }

        public Criteria andAbstractsEqualTo(String value) {
            addCriterion("ABSTRACTS =", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotEqualTo(String value) {
            addCriterion("ABSTRACTS <>", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThan(String value) {
            addCriterion("ABSTRACTS >", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS >=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThan(String value) {
            addCriterion("ABSTRACTS <", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS <=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLike(String value) {
            addCriterion("ABSTRACTS like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotLike(String value) {
            addCriterion("ABSTRACTS not like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsIn(List<String> values) {
            addCriterion("ABSTRACTS in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotIn(List<String> values) {
            addCriterion("ABSTRACTS not in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsBetween(String value1, String value2) {
            addCriterion("ABSTRACTS between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotBetween(String value1, String value2) {
            addCriterion("ABSTRACTS not between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNull() {
            addCriterion("PK_ACCSUBJ is null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNotNull() {
            addCriterion("PK_ACCSUBJ is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjEqualTo(String value) {
            addCriterion("PK_ACCSUBJ =", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <>", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThan(String value) {
            addCriterion("PK_ACCSUBJ >", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ >=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThan(String value) {
            addCriterion("PK_ACCSUBJ <", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLike(String value) {
            addCriterion("PK_ACCSUBJ like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotLike(String value) {
            addCriterion("PK_ACCSUBJ not like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIn(List<String> values) {
            addCriterion("PK_ACCSUBJ in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotIn(List<String> values) {
            addCriterion("PK_ACCSUBJ not in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ not between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNull() {
            addCriterion("SUBJCODE is null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNotNull() {
            addCriterion("SUBJCODE is not null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeEqualTo(String value) {
            addCriterion("SUBJCODE =", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotEqualTo(String value) {
            addCriterion("SUBJCODE <>", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThan(String value) {
            addCriterion("SUBJCODE >", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJCODE >=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThan(String value) {
            addCriterion("SUBJCODE <", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThanOrEqualTo(String value) {
            addCriterion("SUBJCODE <=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLike(String value) {
            addCriterion("SUBJCODE like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotLike(String value) {
            addCriterion("SUBJCODE not like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIn(List<String> values) {
            addCriterion("SUBJCODE in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotIn(List<String> values) {
            addCriterion("SUBJCODE not in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeBetween(String value1, String value2) {
            addCriterion("SUBJCODE between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotBetween(String value1, String value2) {
            addCriterion("SUBJCODE not between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjnameIsNull() {
            addCriterion("SUBJNAME is null");
            return (Criteria) this;
        }

        public Criteria andSubjnameIsNotNull() {
            addCriterion("SUBJNAME is not null");
            return (Criteria) this;
        }

        public Criteria andSubjnameEqualTo(String value) {
            addCriterion("SUBJNAME =", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotEqualTo(String value) {
            addCriterion("SUBJNAME <>", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameGreaterThan(String value) {
            addCriterion("SUBJNAME >", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJNAME >=", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLessThan(String value) {
            addCriterion("SUBJNAME <", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLessThanOrEqualTo(String value) {
            addCriterion("SUBJNAME <=", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLike(String value) {
            addCriterion("SUBJNAME like", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotLike(String value) {
            addCriterion("SUBJNAME not like", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameIn(List<String> values) {
            addCriterion("SUBJNAME in", values, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotIn(List<String> values) {
            addCriterion("SUBJNAME not in", values, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameBetween(String value1, String value2) {
            addCriterion("SUBJNAME between", value1, value2, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotBetween(String value1, String value2) {
            addCriterion("SUBJNAME not between", value1, value2, "subjname");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeIsNull() {
            addCriterion("PK_CURRTYPE is null");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeIsNotNull() {
            addCriterion("PK_CURRTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeEqualTo(String value) {
            addCriterion("PK_CURRTYPE =", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotEqualTo(String value) {
            addCriterion("PK_CURRTYPE <>", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeGreaterThan(String value) {
            addCriterion("PK_CURRTYPE >", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_CURRTYPE >=", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeLessThan(String value) {
            addCriterion("PK_CURRTYPE <", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeLessThanOrEqualTo(String value) {
            addCriterion("PK_CURRTYPE <=", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeLike(String value) {
            addCriterion("PK_CURRTYPE like", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotLike(String value) {
            addCriterion("PK_CURRTYPE not like", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeIn(List<String> values) {
            addCriterion("PK_CURRTYPE in", values, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotIn(List<String> values) {
            addCriterion("PK_CURRTYPE not in", values, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeBetween(String value1, String value2) {
            addCriterion("PK_CURRTYPE between", value1, value2, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotBetween(String value1, String value2) {
            addCriterion("PK_CURRTYPE not between", value1, value2, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andDebitamountIsNull() {
            addCriterion("DEBITAMOUNT is null");
            return (Criteria) this;
        }

        public Criteria andDebitamountIsNotNull() {
            addCriterion("DEBITAMOUNT is not null");
            return (Criteria) this;
        }

        public Criteria andDebitamountEqualTo(BigDecimal value) {
            addCriterion("DEBITAMOUNT =", value, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountNotEqualTo(BigDecimal value) {
            addCriterion("DEBITAMOUNT <>", value, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountGreaterThan(BigDecimal value) {
            addCriterion("DEBITAMOUNT >", value, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("DEBITAMOUNT >=", value, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountLessThan(BigDecimal value) {
            addCriterion("DEBITAMOUNT <", value, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("DEBITAMOUNT <=", value, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountIn(List<BigDecimal> values) {
            addCriterion("DEBITAMOUNT in", values, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountNotIn(List<BigDecimal> values) {
            addCriterion("DEBITAMOUNT not in", values, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("DEBITAMOUNT between", value1, value2, "debitamount");
            return (Criteria) this;
        }

        public Criteria andDebitamountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("DEBITAMOUNT not between", value1, value2, "debitamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountIsNull() {
            addCriterion("CREDITAMOUNT is null");
            return (Criteria) this;
        }

        public Criteria andCreditamountIsNotNull() {
            addCriterion("CREDITAMOUNT is not null");
            return (Criteria) this;
        }

        public Criteria andCreditamountEqualTo(BigDecimal value) {
            addCriterion("CREDITAMOUNT =", value, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountNotEqualTo(BigDecimal value) {
            addCriterion("CREDITAMOUNT <>", value, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountGreaterThan(BigDecimal value) {
            addCriterion("CREDITAMOUNT >", value, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("CREDITAMOUNT >=", value, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountLessThan(BigDecimal value) {
            addCriterion("CREDITAMOUNT <", value, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("CREDITAMOUNT <=", value, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountIn(List<BigDecimal> values) {
            addCriterion("CREDITAMOUNT in", values, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountNotIn(List<BigDecimal> values) {
            addCriterion("CREDITAMOUNT not in", values, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("CREDITAMOUNT between", value1, value2, "creditamount");
            return (Criteria) this;
        }

        public Criteria andCreditamountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("CREDITAMOUNT not between", value1, value2, "creditamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountIsNull() {
            addCriterion("LOCALDEBITAMOUNT is null");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountIsNotNull() {
            addCriterion("LOCALDEBITAMOUNT is not null");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountEqualTo(BigDecimal value) {
            addCriterion("LOCALDEBITAMOUNT =", value, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountNotEqualTo(BigDecimal value) {
            addCriterion("LOCALDEBITAMOUNT <>", value, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountGreaterThan(BigDecimal value) {
            addCriterion("LOCALDEBITAMOUNT >", value, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("LOCALDEBITAMOUNT >=", value, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountLessThan(BigDecimal value) {
            addCriterion("LOCALDEBITAMOUNT <", value, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("LOCALDEBITAMOUNT <=", value, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountIn(List<BigDecimal> values) {
            addCriterion("LOCALDEBITAMOUNT in", values, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountNotIn(List<BigDecimal> values) {
            addCriterion("LOCALDEBITAMOUNT not in", values, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("LOCALDEBITAMOUNT between", value1, value2, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocaldebitamountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("LOCALDEBITAMOUNT not between", value1, value2, "localdebitamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountIsNull() {
            addCriterion("LOCALCREDITAMOUNT is null");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountIsNotNull() {
            addCriterion("LOCALCREDITAMOUNT is not null");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountEqualTo(BigDecimal value) {
            addCriterion("LOCALCREDITAMOUNT =", value, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountNotEqualTo(BigDecimal value) {
            addCriterion("LOCALCREDITAMOUNT <>", value, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountGreaterThan(BigDecimal value) {
            addCriterion("LOCALCREDITAMOUNT >", value, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("LOCALCREDITAMOUNT >=", value, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountLessThan(BigDecimal value) {
            addCriterion("LOCALCREDITAMOUNT <", value, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("LOCALCREDITAMOUNT <=", value, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountIn(List<BigDecimal> values) {
            addCriterion("LOCALCREDITAMOUNT in", values, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountNotIn(List<BigDecimal> values) {
            addCriterion("LOCALCREDITAMOUNT not in", values, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("LOCALCREDITAMOUNT between", value1, value2, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andLocalcreditamountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("LOCALCREDITAMOUNT not between", value1, value2, "localcreditamount");
            return (Criteria) this;
        }

        public Criteria andAssidIsNull() {
            addCriterion("ASSID is null");
            return (Criteria) this;
        }

        public Criteria andAssidIsNotNull() {
            addCriterion("ASSID is not null");
            return (Criteria) this;
        }

        public Criteria andAssidEqualTo(String value) {
            addCriterion("ASSID =", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidNotEqualTo(String value) {
            addCriterion("ASSID <>", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidGreaterThan(String value) {
            addCriterion("ASSID >", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidGreaterThanOrEqualTo(String value) {
            addCriterion("ASSID >=", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidLessThan(String value) {
            addCriterion("ASSID <", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidLessThanOrEqualTo(String value) {
            addCriterion("ASSID <=", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidLike(String value) {
            addCriterion("ASSID like", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidNotLike(String value) {
            addCriterion("ASSID not like", value, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidIn(List<String> values) {
            addCriterion("ASSID in", values, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidNotIn(List<String> values) {
            addCriterion("ASSID not in", values, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidBetween(String value1, String value2) {
            addCriterion("ASSID between", value1, value2, "assid");
            return (Criteria) this;
        }

        public Criteria andAssidNotBetween(String value1, String value2) {
            addCriterion("ASSID not between", value1, value2, "assid");
            return (Criteria) this;
        }

        public Criteria andQtyIsNull() {
            addCriterion("QTY is null");
            return (Criteria) this;
        }

        public Criteria andQtyIsNotNull() {
            addCriterion("QTY is not null");
            return (Criteria) this;
        }

        public Criteria andQtyEqualTo(String value) {
            addCriterion("QTY =", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyNotEqualTo(String value) {
            addCriterion("QTY <>", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyGreaterThan(String value) {
            addCriterion("QTY >", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyGreaterThanOrEqualTo(String value) {
            addCriterion("QTY >=", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyLessThan(String value) {
            addCriterion("QTY <", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyLessThanOrEqualTo(String value) {
            addCriterion("QTY <=", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyLike(String value) {
            addCriterion("QTY like", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyNotLike(String value) {
            addCriterion("QTY not like", value, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyIn(List<String> values) {
            addCriterion("QTY in", values, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyNotIn(List<String> values) {
            addCriterion("QTY not in", values, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyBetween(String value1, String value2) {
            addCriterion("QTY between", value1, value2, "qty");
            return (Criteria) this;
        }

        public Criteria andQtyNotBetween(String value1, String value2) {
            addCriterion("QTY not between", value1, value2, "qty");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    /**
     *  * cw_gl_detail
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * cw_gl_detail 2019-10-14
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}